/* gtools.h : General header for gtools programs. */

#ifndef MAXN 
#define MAXN  0
#endif
#define G6LEN(n)  (((n)*((n)-1)/2+5)/6+(n<=SMALLN?1:4))
		/* Exact length of graph6 code except for \n\0 */

#include "naututil.h"      /* which includes stdio.h */

extern int errno;
#define ABORT(msg) {if (errno != 0) perror(msg); exit(1);}

#define BIAS6 63
#define MAXBYTE 126
#define SMALLN 62
#define TOPBIT6 32
#define C6MASK 63

#define GRAPH6_HEADER ">>graph6<<"
#define SPARSE6_HEADER ">>sparse6<<"

#define GRAPH6         1
#define SPARSE6        2
#define UNKNOWN_TYPE 256
#define HAS_HEADER   512

#define ARG_OK 0
#define ARG_MISSING 1
#define ARG_TOOBIG 2
#define ARG_ILLEGAL 3

#define MAXARG 2000000000L
#define NOLIMIT (MAXARG+31L)

#define SWBOOLEAN(c,bool) if (sw==c) bool=TRUE;
#define SWINT(c,bool,val,id) if (sw==c) \
        {bool=TRUE;arg_int(&arg,&val,id);}
#define SWLONG(c,bool,val,id) if (sw==c) \
        {bool=TRUE;arg_long(&arg,&val,id);}
#define SWRANGE(c,sep,bool,val1,val2,id) if (sw==c) \
	{bool=TRUE;arg_range(&arg,sep,&val1,&val2,id);}

#define HELP if (argc > 1 && (strcmp(argv[1],"-help")==0 \
			   || strcmp(argv[1],"--help")==0)) \
       { printf("\nUsage: %s\n\n%s",USAGE,HELPTEXT); return 0;}

#define alloc_error gt_abort

/************************************************************************/

EXTPROC(FILE *opengraphfile,(char*,int*,boolean,long))
EXTPROC(void writeline,(FILE*,char*))
EXTPROC(char *getline,(FILE*))
EXTPROC(int graphsize,(char*))
EXTPROC(void stringtograph,(char*,graph*,int))
EXTPROC(graph *readg,(FILE*,graph*,int,int*,int*))
EXTPROC(char *ntog6,(graph*,int,int))
EXTPROC(char *ntos6,(graph*,int,int))
EXTPROC(void writeg6,(FILE*,graph*,int,int))
EXTPROC(void writes6,(FILE*,graph*,int,int))
EXTPROC(void writelast,(FILE*))
EXTPROC(int longval,(char**,long*))
EXTPROC(void arg_int,(char**,int*,char*))
EXTPROC(void arg_long,(char**,long*,char*))
EXTPROC(void arg_range,(char**,char*,long*,long*,char*))
EXTPROC(void writerange,(FILE*,int,long,long))
EXTPROC(void gt_abort,(char*))
EXTPROC(char *stringcopy,(char*))

EXTPROC(void fcanonise,(graph*,int,int,graph*,char*))
EXTPROC(void fgroup,(graph*,int,int,char*,int*,int*))
EXTPROC(int istransitive,(graph*,int,int,graph*))
EXTPROC(void tg_canonise,(graph*,graph*,int,int))

extern int readg_code;
extern char *readg_line;
extern long ogf_linelen;

#if !ANSI_STDC
extern char *realloc();
#endif

CPUDEFS
