/* labelled_count.c : write approximate labelled count */
/* Compilation:
     cc -o lgeng -O4 -cg92 -DSUMMARY=summary -DOUTPROC=labcount \
          geng.c labelled_count.c nauty1.o nautil1.o gtools.o; rm geng.o
*/

#define EXTDEFS 1
#define MAXN 32
#include "nauty.h"

static int lastn = -1;
static double nfact;
static double total = 0.0;

extern statsblk nauty_stats;

labcount(FILE *f, graph *g, int n)
{
	int i;
	double lc;

	if (n != lastn)
	{
	    nfact = 1.0;
	    for (i = 2; i <= n; ++i)
		nfact *= i;
	    lastn = n;
	}

	lc = nfact / nauty_stats.grpsize1;
	for (i = 0; i < nauty_stats.grpsize2; ++i)
	    lc /= 10.0;

	total += lc;
}
	
summary(long nout, double cpu)
{
	fprintf(stderr,">Z %ld ",nout);
	if (total >= 1e14) fprintf(stderr," %.13e",total);
	else               fprintf(stderr," %.0f",total);
	fprintf(stderr," cpu=%.2f\n",cpu);
}
